﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace MandelbrotWin
{
    public partial class HlavniOkno : Form
    {
        public HlavniOkno()
        {
            InitializeComponent();
            this.OverOtevrenaOkna();
        }

        public void OverOtevrenaOkna()
        {
            if (this.ActiveMdiChild != null)
            {
                this.editToolStripMenuItem.Enabled = true;
                this.windowToolStripMenuItem.Enabled = true;
                this.saveAsToolStripMenuItem.Enabled = true;
                this.saveToolStripButton.Enabled = true;
                this.saveToolStripMenuItem.Enabled = true;
                this.printPreviewToolStripMenuItem.Enabled = true;
                this.printToolStripButton.Enabled = true;
                this.printToolStripMenuItem.Enabled = true;
            }
            else
            {
                this.editToolStripMenuItem.Enabled = false;
                this.windowToolStripMenuItem.Enabled = false;
                this.saveAsToolStripMenuItem.Enabled = false;
                this.saveToolStripButton.Enabled = false;
                this.saveToolStripMenuItem.Enabled = false;
                this.printPreviewToolStripMenuItem.Enabled = false;
                this.printToolStripButton.Enabled = false;
                this.printToolStripMenuItem.Enabled = false;
            }
        }

        private void novy()
        {
            VnitrniOkno okno = new VnitrniOkno();
            okno.MdiParent = this;
            okno.Show();
            //this.OverOtevrenaOkna();
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.novy();
        }

        private void newToolStripButton_Click(object sender, EventArgs e)
        {
            this.novy();
        }

        private void closeAllStripMenuItem_Click(object sender, EventArgs e)
        {
            foreach (Form f in this.MdiChildren)
            {
                f.Close();
            }
            //this.OverOtevrenaOkna();
        }

        private void closeStripMenuItem_Click(object sender, EventArgs e)
        {
            this.ActiveMdiChild.Close();
            //this.OverOtevrenaOkna();
        }

        private void potomek(object sender, EventArgs e)
        {
            this.OverOtevrenaOkna();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void editParamlToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                VnitrniOkno okno = (VnitrniOkno)this.ActiveMdiChild;
                Parametry p = new Parametry(okno.Sirka, okno.Vyska, okno.Realna,
                    okno.Imaginarni, okno.Meritko, okno.Pos.R, okno.Pos.I, okno.Exponent,
                    okno.Iterace, okno.PalR, okno.PalG, okno.PalB, okno.SouborPalety,
                    okno.Special, this);
                p.ShowDialog();
            }
        }

        private void horToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.TileHorizontal);
        }

        private void verToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.TileVertical);
        }

        private void casStripMenuItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.Cascade);
        }

        private void drawStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                VnitrniOkno o = (VnitrniOkno)this.ActiveMdiChild;
                o.ZacniVykreslovat();
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                VnitrniOkno o = (VnitrniOkno)this.ActiveMdiChild;
                o.Uloz(!o.Pojmenovano);
            }
        }

        private void saveToolStripButton_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                VnitrniOkno o = (VnitrniOkno)this.ActiveMdiChild;
                o.Uloz(!o.Pojmenovano);
            }
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                VnitrniOkno o = (VnitrniOkno)this.ActiveMdiChild;
                o.Uloz(true);
            }
        }

        private void tisk()
        {
            if (this.ActiveMdiChild != null)
            {
                if (this.printDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    this.printDocument1.Print();
                }
            }
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.tisk();
        }

        private void printToolStripButton_Click(object sender, EventArgs e)
        {
            this.tisk();
        }

        private void printPreviewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                this.printPreviewDialog1.ShowDialog();
            }
        }

        private void tiskni(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                Graphics tisk = e.Graphics;
                VnitrniOkno o = (VnitrniOkno)this.ActiveMdiChild;
                Image im = (Image)o.BMP;
                tisk.DrawImage(im, new Point(10, 10));
            }
        }

        private void zobrazNapovedu()
        {
            if (File.Exists("index.html"))
            {
                FileInfo fi = new FileInfo("index.html");
                Napoveda n = new Napoveda("file://" + fi.FullName);
                n.Show();
            }
            else
            {
                MessageBox.Show("Nelze nalézt soubor s nápovědou.\nNachází se tento soubor"
                    + " ve stejné složce jako program?", "Chyba", MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
            }
        }

        private void showToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.zobrazNapovedu();
        }

        private void helpToolStripButton_Click(object sender, EventArgs e)
        {
            this.zobrazNapovedu();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Aplikace na vykreslení výřezu Mandelbrotovy množiny.\n\n"
                + "V prosinci 2010 naprogramoval\nFilip Loužecký\n\nVerze 0.1",
                "O programu...", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }
    }
}
