﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace MandelbrotWin
{
    public partial class Parametry : Form
    {
        private HlavniOkno rodic;

        public Parametry()
        {
            InitializeComponent();
        }

        public Parametry(int sirka, int vyska, double realna, double imaginarni,
            double meritko, double posX, double posY, int exponent, int iterace,
            int r, int g, int b, string souborPalety, bool spec,
            HlavniOkno p_rodic) : this()
        {
            this.numericUpDown1.Value = sirka;
            this.numericUpDown2.Value = vyska;
            this.numericUpDown3.Value = (decimal)realna;
            this.numericUpDown4.Value = (decimal)imaginarni;
            this.numericUpDown5.Value = (decimal)meritko;
            this.numericUpDown6.Value = (decimal)posX;
            this.numericUpDown7.Value = (decimal)posY;
            this.numericUpDown8.Value = exponent;
            this.numericUpDown9.Value = iterace;
            this.numericUpDown10.Value = r;
            this.numericUpDown11.Value = g;
            this.numericUpDown12.Value = b;
            this.textBox1.Text = souborPalety;
            this.radioButton1.Checked = spec;
            this.radioButton2.Checked = !spec;
            this.rodic = p_rodic;
            this.overRadioButtony();
        }

        private void overRadioButtony()
        {
            if (this.radioButton1.Checked)
            {
                this.numericUpDown10.Enabled = true;
                this.numericUpDown11.Enabled = true;
                this.numericUpDown12.Enabled = true;
                this.textBox1.Enabled = false;
                this.button1.Enabled = false;
            }
            if (this.radioButton2.Checked)
            {
                this.numericUpDown10.Enabled = false;
                this.numericUpDown11.Enabled = false;
                this.numericUpDown12.Enabled = false;
                this.textBox1.Enabled = true;
                this.button1.Enabled = true;
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            this.overRadioButtony();
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            this.overRadioButtony();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.textBox1.Text = (this.openFileDialog1.ShowDialog() ==
                System.Windows.Forms.DialogResult.OK) ? this.openFileDialog1.FileName :
                this.textBox1.Text;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if ((this.numericUpDown6.Value < -this.numericUpDown3.Value) ||
                (this.numericUpDown6.Value > this.numericUpDown3.Value))
            {
                MessageBox.Show("X-ová souřadnice středu je mimo absolutní omezení " +
                    "reálné osy.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if ((this.numericUpDown7.Value < -this.numericUpDown4.Value) ||
                (this.numericUpDown7.Value > this.numericUpDown4.Value))
            {
                MessageBox.Show("Y-ová souřadnice středu je mimo absolutní omezení " +
                    "imaginární osy.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            if ((!File.Exists(this.textBox1.Text)) && (this.radioButton2.Checked))
            {
                MessageBox.Show("Zadaný soubor palety neexistuje.", "Chyba",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (this.rodic.ActiveMdiChild == null)
            {
                MessageBox.Show("Není aktivní žádné okno.", "Chyba",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            VnitrniOkno o = (VnitrniOkno)this.rodic.ActiveMdiChild;
            o.Sirka = (int)this.numericUpDown1.Value;
            o.Vyska = (int)this.numericUpDown2.Value;
            o.Realna = (double)this.numericUpDown3.Value;
            o.Imaginarni = (double)this.numericUpDown4.Value;
            o.Meritko = (double)this.numericUpDown5.Value;
            o.Pos.R = (double)this.numericUpDown6.Value;
            o.Pos.I = (double)this.numericUpDown7.Value;
            o.Exponent = (int)this.numericUpDown8.Value;
            o.Iterace = (int)this.numericUpDown9.Value;
            o.PalR = (int)this.numericUpDown10.Value;
            o.PalG = (int)this.numericUpDown11.Value;
            o.PalB = (int)this.numericUpDown12.Value;
            o.SouborPalety = this.textBox1.Text;
            o.Special = this.radioButton1.Checked;
            o.UpravRozmery();
            this.Close();
        }
    }
}
